import structure.*;
import java.awt.*;
import java.awt.event.*;

class GrafEksempel2Frame extends Frame 
	{
	Label label1;
	Label label2;
	Label label3;

	TextField text1;
	TextField text2;
	TextField text3;
	TextField text4;
	
	Button indsaet;
	Button fjern;
	Button query;

	Button indsaetEdge;
	Button fjernEdge;
	Button queryEdge;

	Button status;
	
	TextArea area1;

	GraphMatrix g = new GraphMatrixUndirected(20);
	
	public GrafEksempel2Frame() 
		{
		
		g.add("A");
		g.add("B");
		g.add("C");
		g.add("D");
		g.add("E");
		g.add("F");
		g.add("G");
		g.add("H");
		
		g.addEdge("A", "B", new Integer(5));
		g.addEdge("A", "D", new Integer(7));
		g.addEdge("A", "F", new Integer(6));
		g.addEdge("B", "C", new Integer(3));
		g.addEdge("C", "D", new Integer(2));
		g.addEdge("C", "G", new Integer(8));
		g.addEdge("C", "H", new Integer(5));
		g.addEdge("D", "E", new Integer(3));
		g.addEdge("D", "G", new Integer(6));
		g.addEdge("E", "F", new Integer(4));
		g.addEdge("E", "G", new Integer(2));
		
		setSize(600,400);
		setResizable(false);
		setTitle("Graf eksempel 1");
		setLocation(100,100);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) 
				{
				System.exit(0);
				}
			});

		setLayout(null);
		
		label1 = new Label("Vertex");
		label1.setBounds(10,25,90,20);
		add(label1);
		
		text1 = new TextField();
		text1.setBounds(110,25,90,20);
		text1.setText("");
		add(text1);
		
		indsaet = new Button("Ny vertex");
		indsaet.setBounds(10,50,100,20);
		indsaet.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Indst ny vertex i grafen
  			g.add(text1.getText());
				}
			});
		add(indsaet);
		
		fjern = new Button("Slet vertex");
		fjern.setBounds(210,50,100,20);
		fjern.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Fjern vertex fra grafen
  			g.remove(text1.getText());
				}
			});
		add(fjern);
		
		query = new Button("Query vertex");
		query.setBounds(410,50,100,20);
		query.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Findes en bestemt vertex i grafen?
				String txt = "Vertex: " + text1.getText();
  			if (g.contains(text1.getText()))
  				txt = txt + " findes";
  			else
  				txt = txt + " findes IKKE";
				area1.setText(txt);
				}
			});
		add(query);
		
		label2 = new Label("Edge");
		label2.setBounds(10,100,90,20);
		add(label2);
		
		text2 = new TextField();
		text2.setBounds(110,100,90,20);
		text2.setText("");
		add(text2);
		
		text3 = new TextField();
		text3.setBounds(210,100,90,20);
		text3.setText("");
		add(text3);
		
		text4 = new TextField();
		text4.setBounds(310,100,90,20);
		text4.setText("");
		add(text4);
		
		indsaetEdge = new Button("Ny Edge");
		indsaetEdge.setBounds(10,150,100,20);
		indsaetEdge.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Indst ny edge i grafen
  			g.addEdge(text2.getText(), text3.getText(), new Integer(text4.getText()));
				}
			});
		add(indsaetEdge);
		
		fjernEdge = new Button("Slet Edge");
		fjernEdge.setBounds(210,150,100,20);
		fjernEdge.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Fjern edge fra grafen
  			g.removeEdge(text2.getText(), text3.getText());
				}
			});
		add(fjernEdge);
		
		queryEdge = new Button("Query Edge");
		queryEdge.setBounds(410,150,100,20);
		queryEdge.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Findes en bestemt edge i grafen?
				String txt = "Vertex " + text2.getText();
				txt = txt + " og vertex " + text3.getText();
  			if (g.containsEdge(text2.getText(), text3.getText()))
  				txt = txt + " er forbundet";
  			else
  				txt = txt + " er IKKE forbundet";
				area1.setText(txt);
				}
			});
		add(queryEdge);
		
		area1 = new TextArea();
		area1.setBounds(10,250,580,130);
		add(area1);

		status = new Button();
		status.setBounds(10,200,100,20);
		status.setLabel("Status");
		status.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
				{
				// Udskriv status for grafen
  			area1.setText(g.toString());
				}
			});
		add(status);
		
		}
		
  public static void main (String args[])
	{
		
		GrafEksempel2Frame gui = new GrafEksempel2Frame();
 		gui.setVisible(true);	
		
	}
}